--------------------------------------------------------------------------------------
-- PetFarmChallengeHelper - 
--------------------------------------------------------------------------------------
-- PetFarmChallengeHelper.lua 
--
--[[

PetFarmChallengeHelper is a temporary solution to allow Pet Farm Challenges using
LA/LAC. 

It detects dropped BOP pets and convert the item IDs to those of caged pets 
which have a real item value.

Currently works with LA 2016.v1.6.17

Author: Caraxe
All Rights Reserved

Version 0.0.1 - 2017.10.15
------------------------------------------------------------------------------------]]

local addonName, addon = ...
addon = LibStub("AceAddon-3.0"):NewAddon(addon, addonName, "AceEvent-3.0", "AceConsole-3.0")

local LA = LibStub("AceAddon-3.0"):GetAddon("LootAppraiser")

local OldLATSMGIV = nil
local function NewLATSMGIV(tab, itemID, priceSource)
	local newItemLink = PfchItemID2Species(itemID)

	local oldliv = OldLATSMGIV(tab, itemID, priceSource) or 0
	local newliv = OldLATSMGIV(tab, newItemLink, priceSource) or 0
	if not (oldliv == newliv) then
		print("|cFF33FF99" .. addonName .. "|r:", "changed pet value " .. 
			TSMAPI.Item:GetLink(itemID) .. 
			" from " .. TSMAPI:MoneyToString(oldliv, "OPT_PAD") .. 
			" to " .. TSMAPI:MoneyToString(newliv, "OPT_PAD"));
	end

	return OldLATSMGIV(tab, newItemLink, priceSource)
end	

function addon:OnInitialize()
	-- check LA version and hook only if needed
	if LA then
		if LA.METADATA.VERSION == "2016.v1.6.17" then
			if (LA.TSM.GetItemValue) then
				OldLATSMGIV = LA.TSM.GetItemValue
				LA.TSM.GetItemValue = NewLATSMGIV
				print("|cFF33FF99" .. addonName .. "|r:", " Hooked into LA " .. LA.METADATA.VERSION .. ", dropped pets have real values now.");
			end
		else
			print("|cFF33FF99" .. addonName .. "|r:", " NOT hooked into LA " .. LA.METADATA.VERSION .. ", perhaps " .. addonName .. " has become obsolet.");
		end
	end
end

-- EOF
